------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt_Ada.Internals.Object_Registry;
pragma Elaborate (Qt_Ada.Internals.Object_Registry);

package body Qt_Ada.Internals.Objects.Wizard_Page_Proxies is

   procedure cleanupPage_0_virtual
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
      pragma Import (C, cleanupPage_0_virtual,
                     "__Qt4Ada_QWizardPage_cleanupPage_0_virtual");

   procedure initializePage_0_virtual
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
      pragma Import (C, initializePage_0_virtual,
                     "__Qt4Ada_QWizardPage_initializePage_0_virtual");

   function isComplete_0_virtual
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
      pragma Import (C, isComplete_0_virtual,
                     "__Qt4Ada_QWizardPage_isComplete_0_virtual");

   function nextId_0_virtual
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Q_Integer;
      pragma Import (C, nextId_0_virtual,
                     "__Qt4Ada_QWizardPage_nextId_0_virtual");

   function validatePage_0_virtual
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
      pragma Import (C, validatePage_0_virtual,
                     "__Qt4Ada_QWizardPage_validatePage_0_virtual");

   function Create
    (Object : not null Qt_Ada.Internals.Objects.QObject_Access)
       return not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;

   pragma Style_Checks ("N");

   ------------------
   -- Cleanup_Page --
   ------------------

   procedure Cleanup_Page
    (Self : not null access Q_Wizard_Page_Proxy)
   is
   begin
      cleanupPage_0_virtual
       (Q_Wizard_Page_Proxy'Class (Self.all).QObject_View);
   end Cleanup_Page;

   ---------------------
   -- Initialize_Page --
   ---------------------

   procedure Initialize_Page
    (Self : not null access Q_Wizard_Page_Proxy)
   is
   begin
      initializePage_0_virtual
       (Q_Wizard_Page_Proxy'Class (Self.all).QObject_View);
   end Initialize_Page;

   -----------------
   -- Is_Complete --
   -----------------

   function Is_Complete
    (Self : not null access constant Q_Wizard_Page_Proxy)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isComplete_0_virtual
           (Q_Wizard_Page_Proxy'Class (Self.all).QObject_View));
   end Is_Complete;

   -------------
   -- Next_Id --
   -------------

   function Next_Id
    (Self : not null access constant Q_Wizard_Page_Proxy)
       return Qt4.Q_Integer
   is
   begin
      return
        nextId_0_virtual
         (Q_Wizard_Page_Proxy'Class (Self.all).QObject_View);
   end Next_Id;

   -------------------
   -- Validate_Page --
   -------------------

   function Validate_Page
    (Self : not null access Q_Wizard_Page_Proxy)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (validatePage_0_virtual
           (Q_Wizard_Page_Proxy'Class (Self.all).QObject_View));
   end Validate_Page;

   type Q_Wizard_Page_Proxy_Access is
     access all Q_Wizard_Page_Proxy'Class;

   ------------
   -- Create --
   ------------

   function Create
    (Object : not null Qt_Ada.Internals.Objects.QObject_Access)
       return not null Qt_Ada.Internals.Objects.Q_Object_Base_Access
   is
      Self : constant not null Q_Wizard_Page_Proxy_Access
        := new Q_Wizard_Page_Proxy;

   begin
      Qt_Ada.Internals.Objects.Initialize (Self, Object);

      return Qt_Ada.Internals.Objects.Q_Object_Base_Access (Self);
   end Create;

begin
   Qt_Ada.Internals.Object_Registry.Register_Proxy
    ("QWizardPage", Create'Access);
end Qt_Ada.Internals.Objects.Wizard_Page_Proxies;
